summaryrefslogtreecommitdiff
path: root/test
diff options
context:
space:
mode:
authorLuca Boccassi <bluca@debian.org>2023-05-13 10:23:14 +0100
committerGitHub <noreply@github.com>2023-05-13 10:23:14 +0100
commit942afbad2a4e558bda13b6dd14ee48e08021264d (patch)
tree938e68322e8c2ac4177c45c14a132f9969e7a7bb /test
parentfecbce1fc654076a2fc0922e6d36e5300ea04cdf (diff)
parent7362947c3f3992cf3660b170f46bd80bb5fe1021 (diff)
downloadsystemd-942afbad2a4e558bda13b6dd14ee48e08021264d.tar.gz
Merge pull request #27634 from mrc0mmand/TEST-13-shenanigans
test: clean up & extend the nspawn/machinectl test suite
Diffstat (limited to 'test')
-rwxr-xr-xtest/TEST-13-NSPAWN-SMOKE/test.sh28
-rwxr-xr-xtest/TEST-26-SYSTEMCTL/test.sh4
-rwxr-xr-xtest/TEST-74-AUX-UTILS/test.sh4
-rwxr-xr-xtest/create-busybox-container16
-rw-r--r--test/test-functions5
-rwxr-xr-xtest/units/testsuite-13.machinectl.sh216
-rwxr-xr-xtest/units/testsuite-13.nspawn.sh374
-rwxr-xr-xtest/units/testsuite-13.sh264
-rwxr-xr-xtest/units/testsuite-74.machinectl.sh36
9 files changed, 622 insertions, 325 deletions
diff --git a/test/TEST-13-NSPAWN-SMOKE/test.sh b/test/TEST-13-NSPAWN-SMOKE/test.sh
index 65c1e9be3d..f607c2733b 100755
--- a/test/TEST-13-NSPAWN-SMOKE/test.sh
+++ b/test/TEST-13-NSPAWN-SMOKE/test.sh
@@ -5,26 +5,30 @@ set -e
TEST_DESCRIPTION="systemd-nspawn smoke test"
IMAGE_NAME="nspawn"
TEST_NO_NSPAWN=1
+# The test containers are missing the $BUILD_DIR with the necessary note files
+# which generates lots of errors regarding missing coverage. Since fixing this
+# would make the test code unnecessarily messy, let's just ignore them, at least
+# for now.
+IGNORE_MISSING_COVERAGE=yes
# shellcheck source=test/test-functions
. "${TEST_BASE_DIR:?}/test-functions"
test_append_files() {
- (
- local workspace="${1:?}"
+ local workspace="${1:?}"
- # On openSUSE the static linked version of busybox is named "busybox-static".
- busybox="$(type -P busybox-static || type -P busybox)"
- inst_simple "$busybox" "$(dirname "$busybox")/busybox"
+ # On openSUSE the static linked version of busybox is named "busybox-static".
+ busybox="$(type -P busybox-static || type -P busybox)"
+ inst_simple "$busybox" "$(dirname "$busybox")/busybox"
- if command -v selinuxenabled >/dev/null && selinuxenabled; then
- image_install selinuxenabled
- cp -ar /etc/selinux "$workspace/etc/selinux"
- fi
+ if command -v selinuxenabled >/dev/null && selinuxenabled; then
+ image_install chcon selinuxenabled
+ cp -ar /etc/selinux "$workspace/etc/selinux"
+ sed -i "s/^SELINUX=.*$/SELINUX=permissive/" "$workspace/etc/selinux/config"
+ fi
- "$TEST_BASE_DIR/create-busybox-container" "$workspace/testsuite-13.nc-container"
- initdir="$workspace/testsuite-13.nc-container" image_install nc ip md5sum
- )
+ "$TEST_BASE_DIR/create-busybox-container" "$workspace/testsuite-13.nc-container"
+ initdir="$workspace/testsuite-13.nc-container" image_install nc ip md5sum
}
do_test "$@"
diff --git a/test/TEST-26-SYSTEMCTL/test.sh b/test/TEST-26-SYSTEMCTL/test.sh
index 659311be4d..64accf850f 100755
--- a/test/TEST-26-SYSTEMCTL/test.sh
+++ b/test/TEST-26-SYSTEMCTL/test.sh
@@ -7,8 +7,4 @@ TEST_DESCRIPTION="systemctl-related tests"
# shellcheck source=test/test-functions
. "${TEST_BASE_DIR:?}/test-functions"
-test_append_files() (
- image_install script
-)
-
do_test "$@"
diff --git a/test/TEST-74-AUX-UTILS/test.sh b/test/TEST-74-AUX-UTILS/test.sh
index 94bb159464..f422c89141 100755
--- a/test/TEST-74-AUX-UTILS/test.sh
+++ b/test/TEST-74-AUX-UTILS/test.sh
@@ -7,8 +7,4 @@ TEST_DESCRIPTION="Tests for auxiliary utilities"
# shellcheck source=test/test-functions
. "${TEST_BASE_DIR:?}/test-functions"
-test_append_files() (
- image_install script
-)
-
do_test "$@"
diff --git a/test/create-busybox-container b/test/create-busybox-container
index fca9d6150a..73d8066cc6 100755
--- a/test/create-busybox-container
+++ b/test/create-busybox-container
@@ -1,11 +1,10 @@
#!/usr/bin/env bash
# SPDX-License-Identifier: LGPL-2.1-or-later
-set -e
-set -u
+set -eu
set -o pipefail
-root="${1:?Usage $0 container-root}"
+root="${1:?Usage: $0 container-root}"
mkdir -p "$root"
mkdir "$root/bin"
@@ -16,17 +15,18 @@ cp "$busybox" "$root/bin/busybox"
mkdir -p "$root/usr/lib"
touch "$root/usr/lib/os-release"
-ln -s busybox "$root/bin/sh"
ln -s busybox "$root/bin/cat"
-ln -s busybox "$root/bin/tr"
-ln -s busybox "$root/bin/ps"
ln -s busybox "$root/bin/ip"
+ln -s busybox "$root/bin/md5sum"
+ln -s busybox "$root/bin/ps"
ln -s busybox "$root/bin/seq"
+ln -s busybox "$root/bin/sh"
ln -s busybox "$root/bin/sleep"
-ln -s busybox "$root/bin/usleep"
-ln -s busybox "$root/bin/test"
ln -s busybox "$root/bin/stat"
+ln -s busybox "$root/bin/test"
ln -s busybox "$root/bin/touch"
+ln -s busybox "$root/bin/tr"
+ln -s busybox "$root/bin/usleep"
mkdir -p "$root/sbin"
cat <<'EOF' >"$root/sbin/init"
diff --git a/test/test-functions b/test/test-functions
index 2d303f4799..1f9fa6bb57 100644
--- a/test/test-functions
+++ b/test/test-functions
@@ -193,6 +193,7 @@ BASICTOOLS=(
loadkeys
login
losetup
+ lsattr
lz4cat
mkfifo
mknod
@@ -210,6 +211,7 @@ BASICTOOLS=(
rm
rmdir
rmmod
+ script
sed
seq
setfattr
@@ -808,8 +810,7 @@ setup_selinux() {
ln -sf ../autorelabel.service "$initdir/usr/lib/systemd/tests/testdata/units/basic.target.wants/"
image_install "${fixfiles_tools[@]}"
- image_install fixfiles
- image_install sestatus
+ image_install fixfiles sestatus
}
install_valgrind() {
diff --git a/test/units/testsuite-13.machinectl.sh b/test/units/testsuite-13.machinectl.sh
new file mode 100755
index 0000000000..50dc716230
--- /dev/null
+++ b/test/units/testsuite-13.machinectl.sh
@@ -0,0 +1,216 @@
+#!/usr/bin/env bash
+# SPDX-License-Identifier: LGPL-2.1-or-later
+# shellcheck disable=SC2016
+set -eux
+set -o pipefail
+
+export PAGER=
+
+CREATE_BB_CONTAINER="/usr/lib/systemd/tests/testdata/create-busybox-container"
+
+at_exit() {
+ set +e
+
+ machinectl status long-running >/dev/null && machinectl kill --signal=KILL long-running
+ mountpoint -q /var/lib/machines && timeout 10 sh -c "while ! umount /var/lib/machines; do sleep .5; done"
+ [[ -n "${NSPAWN_FRAGMENT:-}" ]] && rm -f "/etc/systemd/nspawn/$NSPAWN_FRAGMENT" "/var/lib/machines/$NSPAWN_FRAGMENT"
+}
+
+trap at_exit EXIT
+
+# Mount tmpfs over /var/lib/machines to not pollute the image
+mkdir -p /var/lib/machines
+mount -t tmpfs tmpfs /var/lib/machines
+
+# Create a couple of containers we can refer to in tests
+for i in {0..4}; do
+ "$CREATE_BB_CONTAINER" "/var/lib/machines/container$i"
+ machinectl start "container$i"
+done
+# Create one "long running" container with some basic signal handling
+"$CREATE_BB_CONTAINER" /var/lib/machines/long-running
+cat >/var/lib/machines/long-running/sbin/init <<\EOF
+#!/bin/sh -x
+#
+PID=0
+
+# sh doesn't recognize RTMIN+4, so we have to use the signal number directly
+trap "touch /poweroff" 38
+trap "touch /reboot" INT
+trap "touch /trap" TRAP
+trap 'kill $PID' EXIT
+
+# We need to wait for the sleep process asynchronously in order to allow
+# bash to process signals
+sleep infinity &
+PID=$!
+while :; do
+ wait || :
+done
+EOF
+machinectl start long-running
+
+machinectl
+machinectl --no-pager --help
+machinectl --version
+machinectl list
+machinectl list --no-legend --no-ask-password
+
+machinectl status long-running long-running long-running
+machinectl status --full long-running
+machinectl status --quiet --lines=1 long-running
+machinectl status --lines=0 --max-addresses=0 long-running
+machinectl status --machine=testuser@.host long-running
+machinectl status --output=help long-running
+while read -r output; do
+ machinectl status --output="$output" long-running
+done < <(machinectl --output=help)
+
+machinectl show
+machinectl show --all
+machinectl show --all --machine=root@
+machinectl show --all --machine=testuser@
+[[ "$(machinectl show --property=PoolPath --value)" == "/var/lib/machines" ]]
+machinectl show long-running
+machinectl show long-running long-running long-running --all
+[[ "$(machinectl show --property=RootDirectory --value long-running)" == "/var/lib/machines/long-running" ]]
+
+machinectl enable long-running
+test -L /etc/systemd/system/machines.target.wants/systemd-nspawn@long-running.service
+machinectl enable long-running long-running long-running container1
+machinectl disable long-running
+test ! -L /etc/systemd/system/machines.target.wants/systemd-nspawn@long-running.service
+machinectl disable long-running long-running long-running container1
+
+[[ "$(machinectl shell testuser@ /bin/sh -c 'echo -ne $FOO')" == "" ]]
+[[ "$(machinectl shell --setenv=FOO=bar testuser@ /bin/sh -c 'echo -ne $FOO')" == "bar" ]]
+
+[[ "$(machinectl show --property=State --value long-running)" == "running" ]]
+# Equivalent to machinectl kill --signal=SIGRTMIN+4 --kill-whom=leader
+rm -f /var/lib/machines/long-running/poweroff
+machinectl poweroff long-running
+test -e /var/lib/machines/long-running/poweroff
+machinectl poweroff long-running long-running long-running
+# Equivalent to machinectl kill --signal=SIGINT --kill-whom=leader
+rm -f /var/lib/machines/long-running/reboot
+machinectl reboot long-running
+test -e /var/lib/machines/long-running/reboot
+machinectl reboot long-running long-running long-running
+# Skip machinectl terminate for now, as it doesn't play well with our "init"
+rm -f /var/lib/machines/long-running/trap
+machinectl kill --signal=SIGTRAP --kill-whom=leader long-running
+test -e /var/lib/machines/long-running/trap
+machinectl kill --signal=SIGTRAP --kill-whom=leader long-running long-running long-running
+# All used signals should've been caught by a handler
+[[ "$(machinectl show --property=State --value long-running)" == "running" ]]
+
+cp /etc/machine-id /tmp/foo
+machinectl copy-to long-running /tmp/foo /root/foo
+test -f /var/lib/machines/long-running/root/foo
+machinectl copy-from long-running /root/foo /tmp/bar
+diff /tmp/foo /tmp/bar
+rm -f /tmp/{foo,bar}
+
+# machinectl bind is covered by testcase_check_machinectl_bind() in nspawn tests
+
+machinectl list-images
+machinectl list-images --no-legend
+machinectl image-status
+machinectl image-status container1
+machinectl image-status container1 container1 container{0..4}
+machinectl show-image
+machinectl show-image container1
+machinectl show-image container1 container1 container{0..4}
+
+machinectl clone container1 clone1
+machinectl show-image clone1
+machinectl rename clone1 clone2
+(! machinectl show-image clone1)
+machinectl show-image clone2
+if lsattr -d /var/lib/machines >/dev/null; then
+ [[ "$(machinectl show-image --property=ReadOnly --value clone2)" == no ]]
+ machinectl read-only clone2 yes
+ [[ "$(machinectl show-image --property=ReadOnly --value clone2)" == yes ]]
+ machinectl read-only clone2 no
+ [[ "$(machinectl show-image --property=ReadOnly --value clone2)" == no ]]
+fi
+machinectl remove clone2
+for i in {0..4}; do
+ machinectl clone container1 "clone$i"
+done
+machinectl remove clone{0..4}
+for i in {0..4}; do
+ machinectl clone container1 ".hidden$i"
+done
+machinectl list-images --all
+test -d /var/lib/machines/.hidden1
+machinectl clean
+test ! -d /var/lib/machines/.hidden1
+
+# Prepare a simple raw container
+mkdir -p /tmp/mnt
+dd if=/dev/zero of=/tmp/container.raw bs=1M count=32
+mkfs.ext4 /tmp/container.raw
+mount -o loop /tmp/container.raw /tmp/mnt
+cp -r /var/lib/machines/container1/* /tmp/mnt
+umount /tmp/mnt
+# Try to import it, run it, export it, and re-import it
+machinectl import-raw /tmp/container.raw container-raw
+[[ "$(machinectl show-image --property=Type --value container-raw)" == "raw" ]]
+machinectl start container-raw
+machinectl export-raw container-raw /tmp/container-export.raw
+machinectl import-raw /tmp/container-export.raw container-raw-reimport
+[[ "$(machinectl show-image --property=Type --value container-raw-reimport)" == "raw" ]]
+rm -f /tmp/container{,-export}.raw
+
+# Prepare a simple tar.gz container
+tar -pczf /tmp/container.tar.gz -C /var/lib/machines/container1 .
+# Try to import it, run it, export it, and re-import it
+machinectl import-tar /tmp/container.tar.gz container-tar
+[[ "$(machinectl show-image --property=Type --value container-tar)" == "directory" ]]
+machinectl start container-tar
+machinectl export-tar container-tar /tmp/container-export.tar.gz
+machinectl import-tar /tmp/container-export.tar.gz container-tar-reimport
+[[ "$(machinectl show-image --property=Type --value container-tar-reimport)" == "directory" ]]
+rm -f /tmp/container{,-export}.tar.gz
+
+# Try to import a container directory & run it
+cp -r /var/lib/machines/container1 /tmp/container.dir
+machinectl import-fs /tmp/container.dir container-dir
+[[ "$(machinectl show-image --property=Type --value container-dir)" == "directory" ]]
+machinectl start container-dir
+rm -fr /tmp/container.dir
+
+timeout 10 sh -c "while ! machinectl clean --all; do sleep .5; done"
+
+NSPAWN_FRAGMENT="machinectl-test-$RANDOM.nspawn"
+cat >"/var/lib/machines/$NSPAWN_FRAGMENT" <<EOF
+[Exec]
+Boot=true
+EOF
+machinectl cat "$NSPAWN_FRAGMENT"
+EDITOR=true script -qec "machinectl edit $NSPAWN_FRAGMENT" /dev/null
+test -f "/etc/systemd/nspawn/$NSPAWN_FRAGMENT"
+diff "/var/lib/machines/$NSPAWN_FRAGMENT" "/etc/systemd/nspawn/$NSPAWN_FRAGMENT"
+
+cat >/tmp/fragment.nspawn <<EOF
+[Exec]
+Boot=false
+EOF
+machinectl cat /tmp/fragment.nspawn
+EDITOR="cp /tmp/fragment.nspawn" script -qec "machinectl edit $NSPAWN_FRAGMENT" /dev/null
+diff /tmp/fragment.nspawn "/etc/systemd/nspawn/$NSPAWN_FRAGMENT"
+
+for opt in format lines machine max-addresses output setenv verify; do
+ (! machinectl status "--$opt=" long-running)
+ (! machinectl status "--$opt=-1" long-running)
+ (! machinectl status "--$opt=''" long-running)
+done
+(! machinectl show "")
+(! machinectl enable)
+(! machinectl enable "")
+(! machinectl disable)
+(! machinectl disable "")
+(! machinectl read-only container1 "")
+(! machinectl read-only container1 foo)
+(! machinectl read-only container1 -- -1)
diff --git a/test/units/testsuite-13.nspawn.sh b/test/units/testsuite-13.nspawn.sh
new file mode 100755
index 0000000000..c234887d05
--- /dev/null
+++ b/test/units/testsuite-13.nspawn.sh
@@ -0,0 +1,374 @@
+#!/usr/bin/env bash
+# SPDX-License-Identifier: LGPL-2.1-or-later
+# shellcheck disable=SC2016
+set -eux
+set -o pipefail
+
+export SYSTEMD_LOG_LEVEL=debug
+export SYSTEMD_LOG_TARGET=journal
+CREATE_BB_CONTAINER="/usr/lib/systemd/tests/testdata/create-busybox-container"
+
+at_exit() {
+ set +e
+
+ mountpoint -q /var/lib/machines && umount /var/lib/machines
+}
+
+trap at_exit EXIT
+
+# check cgroup-v2
+IS_CGROUPSV2_SUPPORTED=no
+mkdir -p /tmp/cgroup2
+if mount -t cgroup2 cgroup2 /tmp/cgroup2; then
+ IS_CGROUPSV2_SUPPORTED=yes
+ umount /tmp/cgroup2
+fi
+rmdir /tmp/cgroup2
+
+# check cgroup namespaces
+IS_CGNS_SUPPORTED=no
+if [[ -f /proc/1/ns/cgroup ]]; then
+ IS_CGNS_SUPPORTED=yes
+fi
+
+IS_USERNS_SUPPORTED=no
+# On some systems (e.g. CentOS 7) the default limit for user namespaces
+# is set to 0, which causes the following unshare syscall to fail, even
+# with enabled user namespaces support. By setting this value explicitly
+# we can ensure the user namespaces support to be detected correctly.
+sysctl -w user.max_user_namespaces=10000
+if unshare -U sh -c :; then
+ IS_USERNS_SUPPORTED=yes
+fi
+
+# Mount tmpfs over /var/lib/machines to not pollute the image
+mkdir -p /var/lib/machines
+mount -t tmpfs tmpfs /var/lib/machines
+
+testcase_check_bind_tmp_path() {
+ # https://github.com/systemd/systemd/issues/4789
+ local root
+
+ root="$(mktemp -d /var/lib/machines/testsuite-13.bind-tmp-path.XXX)"
+ "$CREATE_BB_CONTAINER" "$root"
+ : >/tmp/bind
+ systemd-nspawn --register=no \
+ --directory="$root" \
+ --bind=/tmp/bind \
+ /bin/sh -c 'test -e /tmp/bind'
+
+ rm -fr "$root" /tmp/bind
+}
+
+testcase_check_norbind() {
+ # https://github.com/systemd/systemd/issues/13170
+ local root
+
+ root="$(mktemp -d /var/lib/machines/testsuite-13.norbind-path.XXX)"
+ mkdir -p /tmp/binddir/subdir
+ echo -n "outer" >/tmp/binddir/subdir/file
+ mount -t tmpfs tmpfs /tmp/binddir/subdir
+ echo -n "inner" >/tmp/binddir/subdir/file
+ "$CREATE_BB_CONTAINER" "$root"
+
+ systemd-nspawn --register=no \
+ --directory="$root" \
+ --bind=/tmp/binddir:/mnt:norbind \
+ /bin/sh -c 'CONTENT=$(cat /mnt/subdir/file); if [[ $CONTENT != "outer" ]]; then echo "*** unexpected content: $CONTENT"; return 1; fi'
+
+ umount /tmp/binddir/subdir
+ rm -fr "$root" /tmp/binddir/
+}
+
+check_rootidmap_cleanup() {
+ local dir="${1:?}"
+
+ mountpoint -q "$dir/bind" && umount "$dir/bind"
+ rm -fr "$dir"
+}
+
+testcase_check_rootidmap() {
+ local root cmd permissions
+ local owner=1000
+
+ root="$(mktemp -d /var/lib/machines/testsuite-13.rootidmap-path.XXX)"
+ # Create ext4 image, as ext4 supports idmapped-mounts.
+ mkdir -p /tmp/rootidmap/bind
+ dd if=/dev/zero of=/tmp/rootidmap/ext4.img bs=4k count=2048
+ mkfs.ext4 /tmp/rootidmap/ext4.img
+ mount /tmp/rootidmap/ext4.img /tmp/rootidmap/bind
+ trap "check_rootidmap_cleanup /tmp/rootidmap/" RETURN
+
+ touch /tmp/rootidmap/bind/file
+ chown -R "$owner:$owner" /tmp/rootidmap/bind
+
+ "$CREATE_BB_CONTAINER" "$root"
+ cmd='PERMISSIONS=$(stat -c "%u:%g" /mnt/file); if [[ $PERMISSIONS != "0:0" ]]; then echo "*** wrong permissions: $PERMISSIONS"; return 1; fi; touch /mnt/other_file'
+ if ! SYSTEMD_LOG_TARGET=console \
+ systemd-nspawn --register=no \
+ --directory="$root" \
+ --bind=/tmp/rootidmap/bind:/mnt:rootidmap \
+ /bin/sh -c "$cmd" |& tee nspawn.out; then
+ if grep -q "Failed to map ids for bind mount.*: Function not implemented" nspawn.out; then
+ echo "idmapped mounts are not supported, skipping the test..."
+ return 0
+ fi
+
+ return 1
+ fi
+
+ permissions=$(stat -c "%u:%g" /tmp/rootidmap/bind/other_file)
+ if [[ $permissions != "$owner:$owner" ]]; then
+ echo "*** wrong permissions: $permissions"
+ [[ "$IS_USERNS_SUPPORTED" == "yes" ]] && return 1
+ fi
+}
+
+testcase_check_notification_socket() {
+ # https://github.com/systemd/systemd/issues/4944
+ local cmd='echo a | $(busybox which nc) -U -u -w 1 /run/host/notify'
+
+ # /testsuite-13.nc-container is prepared by test.sh
+ systemd-nspawn --register=no --directory=/testsuite-13.nc-container /bin/sh -x -c "$cmd"
+ systemd-nspawn --register=no --directory=/testsuite-13.nc-container -U /bin/sh -x -c "$cmd"
+}
+
+testcase_check_os_release() {
+ local root entrypoint os_release_source
+
+ root="$(mktemp -d /var/lib/machines/testsuite-13.check-os-release.XXX)"
+ "$CREATE_BB_CONTAINER" "$root"
+ entrypoint="$root/entrypoint.sh"
+ cat >"$entrypoint" <<\EOF
+#!/bin/sh -ex
+
+. /tmp/os-release
+[[ -n "${ID:-}" && "$ID" != "$container_host_id" ]] && exit 1
+[[ -n "${VERSION_ID:-}" && "$VERSION_ID" != "$container_host_version_id" ]] && exit 1
+[[ -n "${BUILD_ID:-}" && "$BUILD_ID" != "$container_host_build_id" ]] && exit 1
+[[ -n "${VARIANT_ID:-}" && "$VARIANT_ID" != "$container_host_variant_id" ]] && exit 1
+
+cd /tmp
+(cd /run/host && md5sum os-release) | md5sum -c
+EOF
+ chmod +x "$entrypoint"
+
+ os_release_source="/etc/os-release"
+ if [[ ! -r "$os_release_source" ]]; then
+ os_release_source="/usr/lib/os-release"
+ elif [[ -L "$os_release_source" ]]; then
+ # Ensure that /etc always wins if available
+ cp --remove-destination -fv /usr/lib/os-release /etc/os-release
+ echo MARKER=1 >>/etc/os-release
+ fi
+
+ systemd-nspawn --register=no \
+ --directory="$root" \
+ --bind="$os_release_source:/tmp/os-release" \
+ "${entrypoint##"$root"}"
+
+ if grep -q MARKER /etc/os-release; then
+ ln -svrf /usr/lib/os-release /etc/os-release
+ fi
+
+ rm -fr "$root"
+}
+
+testcase_check_machinectl_bind() {
+ local service_path service_name root container_name ec
+ local cmd='for i in $(seq 1 20); do if test -f /tmp/marker; then exit 0; fi; usleep 500000; done; exit 1;'
+
+ root="$(mktemp -d /var/lib/machines/testsuite-13.check-machinectl-bind.XXX)"
+ "$CREATE_BB_CONTAINER" "$root"
+ container_name="${root##*/}"
+
+ service_path="$(mktemp /run/systemd/system/nspawn-machinectl-bind-XXX.service)"
+ service_name="${service_path##*/}"
+ cat >"$service_path" <<EOF
+[Service]
+Type=notify
+ExecStart=systemd-nspawn --directory="$root" --notify-ready=no /bin/sh -xec "$cmd"
+EOF
+
+ systemctl daemon-reload
+ systemctl start "$service_name"
+ touch /tmp/marker
+ machinectl bind --mkdir "$container_name" /tmp/marker
+
+ timeout 10 bash -c "while [[ '\$(systemctl show -P SubState $service_name)' == running ]]; do sleep .2; done"
+ ec="$(systemctl show -P ExecMainStatus "$service_name")"
+
+ rm -fr "$root" "$service_path"
+
+ return "$ec"
+}
+
+testcase_check_selinux() {
+ # Basic test coverage to avoid issues like https://github.com/systemd/systemd/issues/19976
+ if ! command -v selinuxenabled >/dev/null || ! selinuxenabled; then
+ echo >&2 "SELinux is not enabled, skipping SELinux-related tests"
+ return 0
+ fi
+
+ local root
+
+ root="$(mktemp -d /var/lib/machines/testsuite-13.check-selinux.XXX)"
+ "$CREATE_BB_CONTAINER" "$root"
+ chcon -R -t container_t "$root"
+
+ systemd-nspawn --register=no \
+ --boot \
+ --directory="$root" \
+ --selinux-apifs-context=system_u:object_r:container_file_t:s0:c0,c1 \
+ --selinux-context=system_u:system_r:container_t:s0:c0,c1
+
+ rm -fr "$root"
+}
+
+testcase_check_ephemeral_config() {
+ # https://github.com/systemd/systemd/issues/13297
+ local root container_name
+
+ root="$(mktemp -d /var/lib/machines/testsuite-13.check-ephemeral-config.XXX)"
+ "$CREATE_BB_CONTAINER" "$root"
+ container_name="${root##*/}"
+
+ mkdir -p /run/systemd/nspawn/
+ cat >"/run/systemd/nspawn/$container_name.nspawn" <<EOF
+[Files]
+BindReadOnly=/tmp/ephemeral-config
+EOF
+ touch /tmp/ephemeral-config
+
+ systemd-nspawn --register=no \
+ --directory="$root" \
+ --ephemeral \
+ /bin/sh -x -c "test -f /tmp/ephemeral-config"
+
+ systemd-nspawn --register=no \
+ --directory="$root" \
+ --ephemeral \
+ --machine=foobar \
+ /bin/sh -x -c "! test -f /tmp/ephemeral-config"
+
+ rm -fr "$root" "/run/systemd/nspawn/$container_name"
+}
+
+matrix_run_one() {
+ local cgroupsv2="${1:?}"
+ local use_cgns="${2:?}"
+ local api_vfs_writable="${3:?}"
+ local root
+
+ if [[ "$cgroupsv2" == "yes" && "$IS_CGROUPSV2_SUPPORTED" == "no" ]]; then
+ echo >&2 "Unified cgroup hierarchy is not supported, skipping..."
+ return 0
+ fi
+
+ if [[ "$use_cgns" == "yes" && "$IS_CGNS_SUPPORTED" == "no" ]]; then
+ echo >&2 "CGroup namespaces are not supported, skipping..."
+ return 0
+ fi
+
+ root="$(mktemp -d "/var/lib/machines/testsuite-13.unified-$1-cgns-$2-api-vfs-writable-$3.XXX")"
+ "$CREATE_BB_CONTAINER" "$root"
+
+ SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$cgroupsv2" SYSTEMD_NSPAWN_USE_CGNS="$use_cgns" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$api_vfs_writable" \
+ systemd-nspawn --register=no \
+ --directory="$root" \
+ --boot
+
+ SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$cgroupsv2" SYSTEMD_NSPAWN_USE_CGNS="$use_cgns" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$api_vfs_writable" \
+ systemd-nspawn --register=no \
+ --directory="$root" \
+ --private-network \
+ --boot
+
+ if SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$cgroupsv2" SYSTEMD_NSPAWN_USE_CGNS="$use_cgns" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$api_vfs_writable" \
+ systemd-nspawn --register=no \
+ --directory="$root" \
+ --private-users=pick \
+ --boot; then
+ [[ "$IS_USERNS_SUPPORTED" == "yes" && "$api_vfs_writable" == "network" ]] && return 1
+ else
+ [[ "$IS_USERNS_SUPPORTED" == "no" && "$api_vfs_writable" = "network" ]] && return 1
+ fi
+
+ if SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$cgroupsv2" SYSTEMD_NSPAWN_USE_CGNS="$use_cgns" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$api_vfs_writable" \
+ systemd-nspawn --register=no \
+ --directory="$root" \
+ --private-network \
+ --private-users=pick \
+ --boot; then
+ [[ "$IS_USERNS_SUPPORTED" == "yes" && "$api_vfs_writable" == "yes" ]] && return 1
+ else
+ [[ "$IS_USERNS_SUPPORTED" == "no" && "$api_vfs_writable" = "yes" ]] && return 1
+ fi
+
+ local netns_opt="--network-namespace-path=/proc/self/ns/net"
+ local net_opt
+ local net_opts=(
+ "--network-bridge=lo"
+ "--network-interface=lo"
+ "--network-ipvlan=lo"
+ "--network-macvlan=lo"
+ "--network-veth"
+ "--network-veth-extra=lo"
+ "--network-zone=zone"
+ )
+
+ # --network-namespace-path and network-related options cannot be used together
+ for net_opt in "${net_opts[@]}"; do
+ echo "$netns_opt in combination with $net_opt should fail"
+ if SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$cgroupsv2" SYSTEMD_NSPAWN_USE_CGNS="$use_cgns" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$api_vfs_writable" \
+ systemd-nspawn --register=no \
+ --directory="$root" \
+ --boot \
+ "$netns_opt" \
+ "$net_opt"; then
+ echo >&2 "unexpected pass"
+ return 1
+ fi
+ done
+
+ # allow combination of --network-namespace-path and --private-network
+ SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$cgroupsv2" SYSTEMD_NSPAWN_USE_CGNS="$use_cgns" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$api_vfs_writable" \
+ systemd-nspawn --register=no \
+ --directory="$root" \
+ --boot \
+ --private-network \
+ "$netns_opt"
+
+ # test --network-namespace-path works with a network namespace created by "ip netns"
+ ip netns add nspawn_test
+ netns_opt="--network-namespace-path=/run/netns/nspawn_test"
+ SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$cgroupsv2" SYSTEMD_NSPAWN_USE_CGNS="$use_cgns" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$api_vfs_writable" \
+ systemd-nspawn --register=no \
+ --directory="$root" \
+ --network-namespace-path=/run/netns/nspawn_test \
+ /bin/ip a | grep -v -E '^1: lo.*UP'
+ ip netns del nspawn_test
+
+ rm -fr "$root"
+
+ return 0
+}
+
+# Create a list of all functions prefixed with testcase_
+mapfile -t TESTCASES < <(declare -F | awk '$3 ~ /^testcase_/ {print $3;}')
+
+if [[ "${#TESTCASES[@]}" -eq 0 ]]; then
+ echo >&2 "No test cases found, this is most likely an error"
+ exit 1
+fi
+
+for testcase in "${TESTCASES[@]}"; do
+ "$testcase"
+done
+
+for api_vfs_writable in yes no network; do
+ matrix_run_one no no $api_vfs_writable
+ matrix_run_one yes no $api_vfs_writable
+ matrix_run_one no yes $api_vfs_writable
+ matrix_run_one yes yes $api_vfs_writable
+done
diff --git a/test/units/testsuite-13.sh b/test/units/testsuite-13.sh
index 4ad7431e42..5a07e7b78c 100755
--- a/test/units/testsuite-13.sh
+++ b/test/units/testsuite-13.sh
@@ -1,268 +1,14 @@
#!/usr/bin/env bash
# SPDX-License-Identifier: LGPL-2.1-or-later
-# shellcheck disable=SC2016
set -eux
set -o pipefail
-export SYSTEMD_LOG_LEVEL=debug
-export SYSTEMD_LOG_TARGET=journal
+# shellcheck source=test/units/test-control.sh
+. "$(dirname "$0")"/test-control.sh
-# check cgroup-v2
-is_v2_supported=no
-mkdir -p /tmp/cgroup2
-if mount -t cgroup2 cgroup2 /tmp/cgroup2; then
- is_v2_supported=yes
- umount /tmp/cgroup2
-fi
-rmdir /tmp/cgroup2
+: >/failed
-# check cgroup namespaces
-is_cgns_supported=no
-if [[ -f /proc/1/ns/cgroup ]]; then
- is_cgns_supported=yes
-fi
-
-is_user_ns_supported=no
-# On some systems (e.g. CentOS 7) the default limit for user namespaces
-# is set to 0, which causes the following unshare syscall to fail, even
-# with enabled user namespaces support. By setting this value explicitly
-# we can ensure the user namespaces support to be detected correctly.
-sysctl -w user.max_user_namespaces=10000
-if unshare -U sh -c :; then
- is_user_ns_supported=yes
-fi
-
-function check_bind_tmp_path {
- # https://github.com/systemd/systemd/issues/4789
- local _root="/var/lib/machines/testsuite-13.bind-tmp-path"
- rm -rf "$_root"
- /usr/lib/systemd/tests/testdata/create-busybox-container "$_root"
- : >/tmp/bind
- systemd-nspawn --register=no -D "$_root" --bind=/tmp/bind /bin/sh -c 'test -e /tmp/bind'
-}
-
-function check_norbind {
- # https://github.com/systemd/systemd/issues/13170
- local _root="/var/lib/machines/testsuite-13.norbind-path"
- rm -rf "$_root"
- mkdir -p /tmp/binddir/subdir
- echo -n "outer" >/tmp/binddir/subdir/file
- mount -t tmpfs tmpfs /tmp/binddir/subdir
- echo -n "inner" >/tmp/binddir/subdir/file
- /usr/lib/systemd/tests/testdata/create-busybox-container "$_root"
- systemd-nspawn --register=no -D "$_root" --bind=/tmp/binddir:/mnt:norbind /bin/sh -c 'CONTENT=$(cat /mnt/subdir/file); if [[ $CONTENT != "outer" ]]; then echo "*** unexpected content: $CONTENT"; return 1; fi'
-}
-
-function check_rootidmap {
- local _owner=1000
- local _root="/var/lib/machines/testsuite-13.rootidmap-path"
- local _command
- rm -rf "$_root"
-
- # Create ext4 image, as ext4 supports idmapped-mounts.
- dd if=/dev/zero of=/tmp/ext4.img bs=4k count=2048
- mkfs.ext4 /tmp/ext4.img
- mkdir -p /tmp/rootidmapdir
- mount /tmp/ext4.img /tmp/rootidmapdir
-
- touch /tmp/rootidmapdir/file
- chown -R $_owner:$_owner /tmp/rootidmapdir
-
- /usr/lib/systemd/tests/testdata/create-busybox-container "$_root"
- _command='PERMISSIONS=$(stat -c "%u:%g" /mnt/file); if [[ $PERMISSIONS != "0:0" ]]; then echo "*** wrong permissions: $PERMISSIONS"; return 1; fi; touch /mnt/other_file'
- if ! SYSTEMD_LOG_TARGET=console systemd-nspawn \
- --register=no -D "$_root" \
- --bind=/tmp/rootidmapdir:/mnt:rootidmap \
- /bin/sh -c "$_command" |& tee nspawn.out; then
- if grep -q "Failed to map ids for bind mount.*: Function not implemented" nspawn.out; then
- echo "idmapped mounts are not supported, skipping the test..."
- return 0
- fi
-
- return 1
- fi
-
- PERMISSIONS=$(stat -c "%u:%g" /tmp/rootidmapdir/other_file)
- if [[ $PERMISSIONS != "$_owner:$_owner" ]]; then
- echo "*** wrong permissions: $PERMISSIONS"
- [[ "$is_user_ns_supported" = "yes" ]] && return 1
- fi
-}
-
-function check_notification_socket {
- # https://github.com/systemd/systemd/issues/4944
- local _cmd='echo a | $(busybox which nc) -U -u -w 1 /run/host/notify'
- # /testsuite-13.nc-container is prepared by test.sh
- systemd-nspawn --register=no -D /testsuite-13.nc-container /bin/sh -x -c "$_cmd"
- systemd-nspawn --register=no -D /testsuite-13.nc-container -U /bin/sh -x -c "$_cmd"
-}
-
-function check_os_release {
- local _cmd='. /tmp/os-release
-if [ -n "${ID:+set}" ] && [ "${ID}" != "${container_host_id}" ]; then exit 1; fi
-if [ -n "${VERSION_ID:+set}" ] && [ "${VERSION_ID}" != "${container_host_version_id}" ]; then exit 1; fi
-if [ -n "${BUILD_ID:+set}" ] && [ "${BUILD_ID}" != "${container_host_build_id}" ]; then exit 1; fi
-if [ -n "${VARIANT_ID:+set}" ] && [ "${VARIANT_ID}" != "${container_host_variant_id}" ]; then exit 1; fi
-cd /tmp; (cd /run/host; md5sum os-release) | md5sum -c
-if echo test >>/run/host/os-release; then exit 1; fi
-'
-
- local _os_release_source="/etc/os-release"
- if [[ ! -r "${_os_release_source}" ]]; then
- _os_release_source="/usr/lib/os-release"
- elif [[ -L "${_os_release_source}" ]] && rm /etc/os-release; then
- # Ensure that /etc always wins if available
- cp /usr/lib/os-release /etc
- echo MARKER=1 >>/etc/os-release
- fi
-
- systemd-nspawn --register=no -D /testsuite-13.nc-container --bind="${_os_release_source}":/tmp/os-release /bin/sh -x -e -c "$_cmd"
-
- if grep -q MARKER /etc/os-release; then
- rm /etc/os-release
- ln -s ../usr/lib/os-release /etc/os-release
- fi
-}
-
-function check_machinectl_bind {
- local _cmd='for i in $(seq 1 20); do if test -f /tmp/marker; then exit 0; fi; usleep 500000; done; exit 1;'
-
- cat >/run/systemd/system/nspawn_machinectl_bind.service <<EOF
-[Service]
-Type=notify
-ExecStart=systemd-nspawn ${SUSE_OPTS[@]} -D /testsuite-13.nc-container --notify-ready=no /bin/sh -x -e -c "$_cmd"
-EOF
-
- systemctl start nspawn_machinectl_bind.service
-
- touch /tmp/marker
-
- machinectl bind --mkdir testsuite-13.nc-container /tmp/marker
-
- while systemctl show -P SubState nspawn_machinectl_bind.service | grep -q running
- do
- sleep 0.1
- done
-
- return "$(systemctl show -P ExecMainStatus nspawn_machinectl_bind.service)"
-}
-
-function check_selinux {
- if ! command -v selinuxenabled >/dev/null || ! selinuxenabled; then
- echo >&2 "SELinux is not enabled, skipping SELinux-related tests"
- return 0
- fi
-
- # Basic test coverage to avoid issues like https://github.com/systemd/systemd/issues/19976
- systemd-nspawn "${SUSE_OPTS[@]}" --register=no -b -D /testsuite-13.nc-container --selinux-apifs-context=system_u:object_r:container_file_t:s0:c0,c1 --selinux-context=system_u:system_r:container_t:s0:c0,c1
-}
-
-function check_ephemeral_config {
- # https://github.com/systemd/systemd/issues/13297
-
- mkdir -p /run/systemd/nspawn/
- cat >/run/systemd/nspawn/testsuite-13.nc-container.nspawn <<EOF
-[Files]
-BindReadOnly=/tmp/ephemeral-config
-EOF
- touch /tmp/ephemeral-config
-
- # /testsuite-13.nc-container is prepared by test.sh
- systemd-nspawn --register=no -D /testsuite-13.nc-container --ephemeral /bin/sh -x -c "test -f /tmp/ephemeral-config"
-
- systemd-nspawn --register=no -D /testsuite-13.nc-container --ephemeral --machine foobar /bin/sh -x -c "! test -f /tmp/ephemeral-config"
-
- rm -f /run/systemd/nspawn/testsuite-13.nc-container.nspawn
-}
-
-function run {
- if [[ "$1" = "yes" && "$is_v2_supported" = "no" ]]; then
- printf "Unified cgroup hierarchy is not supported. Skipping.\n" >&2
- return 0
- fi
- if [[ "$2" = "yes" && "$is_cgns_supported" = "no" ]]; then
- printf "CGroup namespaces are not supported. Skipping.\n" >&2
- return 0
- fi
-
- local _root="/var/lib/machines/testsuite-13.unified-$1-cgns-$2-api-vfs-writable-$3"
- rm -rf "$_root"
- /usr/lib/systemd/tests/testdata/create-busybox-container "$_root"
- SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$1" SYSTEMD_NSPAWN_USE_CGNS="$2" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$3" systemd-nspawn --register=no -D "$_root" -b
- SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$1" SYSTEMD_NSPAWN_USE_CGNS="$2" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$3" systemd-nspawn --register=no -D "$_root" --private-network -b
-
- if SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$1" SYSTEMD_NSPAWN_USE_CGNS="$2" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$3" systemd-nspawn --register=no -D "$_root" -U -b; then
- [[ "$is_user_ns_supported" = "yes" && "$3" = "network" ]] && return 1
- else
- [[ "$is_user_ns_supported" = "no" && "$3" = "network" ]] && return 1
- fi
-
- if SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$1" SYSTEMD_NSPAWN_USE_CGNS="$2" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$3" systemd-nspawn --register=no -D "$_root" --private-network -U -b; then
- [[ "$is_user_ns_supported" = "yes" && "$3" = "yes" ]] && return 1
- else
- [[ "$is_user_ns_supported" = "no" && "$3" = "yes" ]] && return 1
- fi
-
- local _netns_opt="--network-namespace-path=/proc/self/ns/net"
- local _net_opts=(
- "--network-bridge=lo"
- "--network-interface=lo"
- "--network-ipvlan=lo"
- "--network-macvlan=lo"
- "--network-veth"
- "--network-veth-extra=lo"
- "--network-zone=zone"
- )
-
- # --network-namespace-path and network-related options cannot be used together
- for netopt in "${_net_opts[@]}"; do
- echo "$_netns_opt in combination with $netopt should fail"
- if SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$1" SYSTEMD_NSPAWN_USE_CGNS="$2" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$3" systemd-nspawn --register=no -D "$_root" -b "$_netns_opt" "$netopt"; then
- echo >&2 "unexpected pass"
- return 1
- fi
- done
-
- # allow combination of --network-namespace-path and --private-network
- if ! SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$1" SYSTEMD_NSPAWN_USE_CGNS="$2" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$3" systemd-nspawn --register=no -D "$_root" -b "$_netns_opt" --private-network; then
- return 1
- fi
-
- # test --network-namespace-path works with a network namespace created by "ip netns"
- ip netns add nspawn_test
- _netns_opt="--network-namespace-path=/run/netns/nspawn_test"
- SYSTEMD_NSPAWN_UNIFIED_HIERARCHY="$1" SYSTEMD_NSPAWN_USE_CGNS="$2" SYSTEMD_NSPAWN_API_VFS_WRITABLE="$3" systemd-nspawn --register=no -D "$_root" "$_netns_opt" /bin/ip a | grep -v -E '^1: lo.*UP'
- local r=$?
- ip netns del nspawn_test
-
- if [[ $r -ne 0 ]]; then
- return 1
- fi
-
- return 0
-}
-
-check_bind_tmp_path
-
-check_norbind
-
-check_rootidmap
-
-check_notification_socket
-
-check_os_release
-
-for api_vfs_writable in yes no network; do
- run no no $api_vfs_writable
- run yes no $api_vfs_writable
- run no yes $api_vfs_writable
- run yes yes $api_vfs_writable
-done
-
-check_machinectl_bind
-
-check_selinux
-
-check_ephemeral_config
+run_subtests
touch /testok
+rm /failed
diff --git a/test/units/testsuite-74.machinectl.sh b/test/units/testsuite-74.machinectl.sh
deleted file mode 100755
index 3d8d07c87d..0000000000
--- a/test/units/testsuite-74.machinectl.sh
+++ /dev/null
@@ -1,36 +0,0 @@
-#!/usr/bin/env bash
-# SPDX-License-Identifier: LGPL-2.1-or-later
-# shellcheck disable=SC2016
-set -eux
-set -o pipefail
-
-# shellcheck source=test/units/assert.sh
-. "$(dirname "$0")"/assert.sh
-
-at_exit() {
- if [[ -v NSPAWN_NAME && -e "/var/lib/machines/$NSPAWN_NAME" ]]; then
- rm -fvr "/var/lib/machines/$NSPAWN_NAME" "/etc/systemd/nspawn/$NSPAWN_NAME" "new"
- fi
-}
-
-trap at_exit EXIT
-
-export NSPAWN_NAME="machinectl-test-$RANDOM.nspawn"
-cat >"/var/lib/machines/$NSPAWN_NAME" <<\EOF
-[Exec]
-Boot=true
-EOF
-
-EDITOR='true' script -ec 'machinectl edit "$NSPAWN_NAME"' /dev/null
-[ -f "/etc/systemd/nspawn/$NSPAWN_NAME" ]
-cmp "/var/lib/machines/$NSPAWN_NAME" "/etc/systemd/nspawn/$NSPAWN_NAME"
-
-cat >new <<\EOF
-[Exec]
-Boot=false
-EOF
-
-script -ec 'machinectl cat "$PWD/new"' /dev/null
-
-EDITOR='mv new' script -ec 'machinectl edit "$NSPAWN_NAME"' /dev/null
-printf '%s\n' '[Exec]' 'Boot=false' | cmp - "/etc/systemd/nspawn/$NSPAWN_NAME"